PRO LDRS_HALO_REFLECT, psf, sl, sr, sb, st, haloCFG, intData, iImage
hcfg = haloCFG->GetFirst()
kernel = FLTARR(31,31)
ksigma = 8.0
FOR x=0,30 DO BEGIN
    hx = FLOAT(x - 15)
    FOR y=0,30 DO BEGIN
        hy = FLOAT(y - 15)
        kernel[x,y] = EXP(-(hx*hx + hy*hy)/(2*ksigma*ksigma))
    ENDFOR
ENDFOR
kernel /= TOTAL(kernel)
halo = CONVOL((*intData)[*, *, iImage], kernel)
WHILE OBJ_VALID(hcfg) DO BEGIN
    hcfg->GetFloat2D, 'POS', hx, hy
    hcfg->GetFloat2D, 'LIMIT', il, ol
    sky1 = hcfg->GetFloat('SKY1')
    hil = il*il
    hol = ol*ol
    FOR x=sl,sr DO BEGIN
        dx = x - hx
        hdx = dx*dx
        IF hdx LT hil THEN CONTINUE
        IF hdx GT hol THEN CONTINUE
        FOR y=sb,st DO BEGIN
            dy = y - hy
            hdy = dy*dy
            IF (hdx + hdy) LT hil THEN CONTINUE
            IF (hdx + hdy) GT hol THEN CONTINUE
            ;hv = (*intData)[hx - dx, hy-dy, iImage] - sky1
            hv = halo[hx - dx, hy - dy] - sky1
            psf[x-sl,y-sb] -= hv
        ENDFOR
    ENDFOR
    hcfg = hcfg->GetNext()
ENDWHILE
END

