FUNCTION ldrsAREATOOL::Init, view
IF NOT self->ldrsPOINTTOOL::Init(view) THEN RETURN, 0
self.dlgTitle = 'Area'
self.cfgPlace = 'IMGAREA'
self.objClass = 'ldrsIMGAREA'
self.labelPrefix = 'Area '
self.mVisible = 1
RETURN, 1
END

PRO ldrsAREATOOL::InitObject, obj, x, y
self->ldrsPOINTTOOL::InitObject, obj, x, y
CASE self.mMode OF
    0: obj->SetSize, LEFT=self.mDefLeft, RIGHT=self.mDefRight, BOTTOM=self.mDefBottom, TOP=self.mDefTop
    1: obj->SetSize, WIDTH=self.mDefWidth, HEIGHT=self.mDefHeight
    2: obj->SetSize, SIZE=self.mDefSize
    3: obj->SetSize, WIDTH=self.mDefWidth, HEIGHT=self.mDefHeight
ELSE:
ENDCASE
END

PRO ldrsAREATOOL::ReadDynamicContent
self->ldrsPOINTTOOL::ReadDynamicContent
self.infoObj->GetMargins, l, r, t, b
IF self.mVisible THEN BEGIN
    CASE self.mMode OF
        0: BEGIN
            self.mLeft = l
            self.mRight = r
            self.mBottom = b
            self.mTop = t
            WIDGET_CONTROL, self.dBoxLeft, SET_VALUE=STRING(self.mLeft)
            WIDGET_CONTROL, self.dBoxRight, SET_VALUE=STRING(self.mRight)
            WIDGET_CONTROL, self.dBoxTop, SET_VALUE=STRING(self.mBottom)
            WIDGET_CONTROL, self.dBoxBottom, SET_VALUE=STRING(self.mTop)
        END
        1: BEGIN
            self.mWidth = l + r
            self.mHeight = b + t
            WIDGET_CONTROL, self.dBoxWidth, SET_VALUE=STRING(self.mWidth)
            WIDGET_CONTROL, self.dBoxHeight, SET_VALUE=STRING(self.mHeight)
        END
        2: BEGIN
            self.mSize = l + r
            WIDGET_CONTROL, self.dBoxSize, SET_VALUE=STRING(self.mSize)
        END
        3: BEGIN
            self.mWidth = l + r
            self.mHeight = b + t
            WIDGET_CONTROL, self.dBoxWidth, SET_VALUE=STRING(self.mWidth)
            WIDGET_CONTROL, self.dBoxHeight, SET_VALUE=STRING(self.mHeight)
        END
        ELSE:
    ENDCASE
ENDIF
self.infoObj->GetSky, skyAlgo, sky1, sky2, sky3, sky4
self.skyAlgo = skyAlgo
self.sky1 = sky1
self.sky2 = sky2
self.sky3 = sky3
self.sky4 = sky4
WIDGET_CONTROL, self.dSkyAlgo, SET_COMBOBOX_SELECT=skyAlgo
WIDGET_CONTROL, self.dSky1, SET_VALUE=STRING(sky1)
WIDGET_CONTROL, self.dSky2, SET_VALUE=STRING(sky2)
WIDGET_CONTROL, self.dSky3, SET_VALUE=STRING(sky3)
WIDGET_CONTROL, self.dSky4, SET_VALUE=STRING(sky4)
END

PRO ldrsAREATOOL::WriteDynamicContent
self->ldrsPOINTTOOL::WriteDynamicContent
IF self.mVisible THEN BEGIN
    CASE self.mMode OF
        0: BEGIN
            WIDGET_CONTROL, self.dBoxLeft, GET_VALUE=str1
            WIDGET_CONTROL, self.dBoxRight, GET_VALUE=str2
            WIDGET_CONTROL, self.dBoxTop, GET_VALUE=str3
            WIDGET_CONTROL, self.dBoxBottom, GET_VALUE=str4
            self.mLeft = FLOAT(str1)
            self.mRight = FLOAT(str2)
            self.mTop = FLOAT(str3)
            self.mBottom = FLOAT(str4)
            self.infoObj->SetSize, LEFT=self.mLeft, RIGHT=self.mRight, BOTTOM=self.mBottom, TOP=self.mTop
        END
        1: BEGIN
            WIDGET_CONTROL, self.dBoxWidth, GET_VALUE=str1
            WIDGET_CONTROL, self.dBoxHeight, GET_VALUE=str2
            self.mWidth = FLOAT(str1)
            self.mHeight = FLOAT(str2)
            self.infoObj->SetSize, WIDTH=self.mWidth, HEIGHT=self.mHeight
        END
        2: BEGIN
            WIDGET_CONTROL, self.dBoxSize, GET_VALUE=str1
            self.mSize = FLOAT(str1)
            self.infoObj->SetSize, SIZE=self.mSize
        END
        3: BEGIN
            WIDGET_CONTROL, self.dBoxWidth, GET_VALUE=str1
            WIDGET_CONTROL, self.dBoxHeight, GET_VALUE=str2
            self.mWidth = FLOAT(str1)
            self.mHeight = FLOAT(str2)
            self.infoObj->SetSize, WIDTH=self.mWidth, HEIGHT=self.mHeight
        END
        ELSE:
    ENDCASE
ENDIF
WIDGET_CONTROL, self.dSky1, GET_VALUE=str1
WIDGET_CONTROL, self.dSky2, GET_VALUE=str2
WIDGET_CONTROL, self.dSky3, GET_VALUE=str3
WIDGET_CONTROL, self.dSky4, GET_VALUE=str4
self.sky1 = FLOAT(str1)
self.sky2 = FLOAT(str2)
self.sky3 = FLOAT(str3)
self.sky4 = FLOAT(str4)
self.infoObj->SetSky, self.skyAlgo, self.sky1, self.sky2, self.sky3, self.sky4
END

PRO ldrsAREATOOL::SetSky, id, item
self.skyAlgo = item
END

PRO ldrsAREATOOL::GetBoundingBoxFromDialog, x, y, w, h
IF NOT self.mVisible THEN RETURN
; get the current values from the dialog window
WIDGET_CONTROL, self.dPosX, GET_VALUE=str1
WIDGET_CONTROL, self.dPosY, GET_VALUE=str2
px = FLOAT(str1)
py = FLOAT(str2)
CASE self.mMode OF
    0: BEGIN
        WIDGET_CONTROL, self.dBoxLeft, GET_VALUE=str1
        WIDGET_CONTROL, self.dBoxRight, GET_VALUE=str2
        WIDGET_CONTROL, self.dBoxTop, GET_VALUE=str3
        WIDGET_CONTROL, self.dBoxBottom, GET_VALUE=str4
        l = FLOAT(str1)
        r = FLOAT(str2)
        t = FLOAT(str3)
        b = FLOAT(str4)
    END
    1: BEGIN
        WIDGET_CONTROL, self.dBoxWidth, GET_VALUE=str1
        WIDGET_CONTROL, self.dBoxHeight, GET_VALUE=str2
        dw = FLOAT(str1)
        dh = FLOAT(str2)
        l = dw/2
        r = dw/2
        b = dh/2
        t = dh/2
    END
    2: BEGIN
        WIDGET_CONTROL, self.dBoxSize, GET_VALUE=str1
        ds = FLOAT(str1)
        l = ds/2
        r = ds/2
        b = ds/2
        t = ds/2
    END
    3: BEGIN
        WIDGET_CONTROL, self.dBoxWidth, GET_VALUE=str1
        WIDGET_CONTROL, self.dBoxHeight, GET_VALUE=str2
        dw = FLOAT(str1)
        dh = FLOAT(str2)
        l = 0
        r = dw
        b = 0
        t = dh
    END
    ELSE:
ENDCASE
x = px - l
y = py - b
w = l + r
h = b + t
END

PRO ldrsAREATOOL::ButtonPressed, id
self->ldrsPOINTTOOL::ButtonPressed, id
IF id EQ self.dSkyGuess THEN BEGIN
    self->GetBoundingBoxFromDialog, x, y, w, h
    self.view->GetImage, image, nr
    IF NOT PTR_VALID(image) THEN BEGIN
        PRINT, 'ldrsAREATOOL::ButtonPressed, self.dSkyGuess => sorry, but no current image!'
        RETURN                  ; sorry, but no current image!
    ENDIF
    sl = FIX(x + 0.5)
    sr = FIX(x + w + 0.5) - 1
    sb = FIX(y + 0.5)
    st = FIX(y + h + 0.5) - 1
    area = (*image)[sl : sr, sb : st, nr]
    proc = LDRS_GET_PROCEDURE('SKYPE', self.skyAlgo)
    CALL_PROCEDURE, proc, area, s1, s2, s3, s4
    self.sky1 = s1
    self.sky2 = s2
    self.sky3 = s3
    self.sky4 = s4
    ; show the calculated values in the dialog window
    WIDGET_CONTROL, self.dSky1, SET_VALUE=STRING(self.sky1)
    WIDGET_CONTROL, self.dSky2, SET_VALUE=STRING(self.sky2)
    WIDGET_CONTROL, self.dSky3, SET_VALUE=STRING(self.sky3)
    WIDGET_CONTROL, self.dSky4, SET_VALUE=STRING(self.sky4)
ENDIF
END

PRO ldrsAREATOOL::CreateContent
self->ldrsPOINTTOOL::CreateContent
row = self->GetFreeRow()
IF self.mVisible THEN BEGIN
    CASE self.mMode OF
        0: BEGIN
            lab              = self->CreateLabel(0, row, 'Margins:', /HALIGN_RIGHT)
            lab              = self->CreateLabel(1, row, 'left=', /HALIGN_RIGHT)
            self.dBoxLeft    = self->CreateEntry(2, row, VALUE=STRING(0.0))
            lab              = self->CreateLabel(3, row, 'right=', /HALIGN_RIGHT)
            self.dBoxRight   = self->CreateEntry(4, row, VALUE=STRING(0.0))
            row++
            lab              = self->CreateLabel(1, row, 'top=', /HALIGN_RIGHT)
            self.dBoxTop     = self->CreateEntry(2, row, VALUE=STRING(0.0))
            lab              = self->CreateLabel(3, row, 'bottom=', /HALIGN_RIGHT)
            self.dBoxBottom  = self->CreateEntry(4, row, VALUE=STRING(0.0))
        END
        1: BEGIN
            lab              = self->CreateLabel(0, row, 'Size:', /HALIGN_RIGHT)
            lab              = self->CreateLabel(1, row, 'width=', /HALIGN_RIGHT)
            self.dBoxWidth    = self->CreateEntry(2, row, VALUE=STRING(0.0))
            lab              = self->CreateLabel(3, row, 'height=', /HALIGN_RIGHT)
            self.dBoxHeight   = self->CreateEntry(4, row, VALUE=STRING(0.0))
        END
        2: BEGIN
            lab              = self->CreateLabel(0, row, 'Size:', /HALIGN_RIGHT)
            self.dBoxSize    = self->CreateEntry(2, row, VALUE=STRING(0.0))
        END
        3: BEGIN
            lab              = self->CreateLabel(0, row, 'Size:', /HALIGN_RIGHT)
            lab              = self->CreateLabel(1, row, 'width=', /HALIGN_RIGHT)
            self.dBoxWidth    = self->CreateEntry(2, row, VALUE=STRING(0.0))
            lab              = self->CreateLabel(3, row, 'height=', /HALIGN_RIGHT)
            self.dBoxHeight   = self->CreateEntry(4, row, VALUE=STRING(0.0))
        END
        ELSE:
    ENDCASE
    row++
ENDIF
lab              = self->CreateLabel(0, row, 'Sky:', /HALIGN_RIGHT)
self.dSkyAlgo    = self->CreateProcedureMenu(2, row, 'SKYC', 'SetSky')
self.dSkyGuess   = self->CreateButton(3, row, 'Estimate', /HALIGN_LEFT, NX=2)
row++
lab              = self->CreateLabel(1, row, 'p1=', /HALIGN_RIGHT)
self.dSky1       = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab              = self->CreateLabel(3, row, 'p2=', /HALIGN_RIGHT)
self.dSky2       = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
lab              = self->CreateLabel(1, row, 'p3=', /HALIGN_RIGHT)
self.dSky3       = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab              = self->CreateLabel(3, row, 'p4=', /HALIGN_RIGHT)
self.dSky4       = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
END

PRO ldrsAREATOOL__define
struct = { ldrsAREATOOL, $
           INHERITS ldrsPOINTTOOL, $
           mMode:0, mVisible:1, $
           mSize:0.0, $
           mDefSize:0.0, $
           dBoxSize:0, $
           mWidth:0.0, mHeight:0.0, $
           mDefWidth:0.0, mDefHeight:0.0, $
           dBoxWidth:0, dBoxHeight:0, $
           mLeft:0.0, mRight:0.0, mBottom:0.0, mTop:0.0, $
           mDefLeft:0.0, mDefRight:0.0, mDefBottom:0.0, mDefTop:0.0, $
           dBoxLeft:0, dBoxRight:0, dBoxBottom:0, dBoxTop:0, $
           skyAlgo:-1, sky1:0.0, sky2:0.0, sky3:0.0, sky4:0.0, $
           dSkyAlgo:0, dSkyGuess:0, dSky1:0, dSky2:0, dSky3:0, dSky4:0 $
         }
END

