FUNCTION ldrsHALOTOOL::Init, view
IF NOT self->ldrsAREATOOL::Init(view) THEN RETURN, 0
self.dlgTitle = 'Halo'
self.cfgPlace = 'HALO'
self.objClass = 'ldrsHALO'
self.labelPrefix = 'Halo '
self.mMode = 2
self.mVisible = 0
RETURN, 1
END

PRO ldrsHALOTOOL::DoRecenter
self.infoObj->AdjustCenter
self.view->Redraw
self->ReadDynamicContent
END

PRO ldrsHALOTOOL::ReadDynamicContent
self->ldrsAREATOOL::ReadDynamicContent
self.infoObj->GetRing, inner, outer
WIDGET_CONTROL, self.dInnerRing, SET_VALUE=STRING(inner)
WIDGET_CONTROL, self.dOuterRing, SET_VALUE=STRING(outer)
self.infoObj->GetLimits, inner, outer
WIDGET_CONTROL, self.dInnerLimit, SET_VALUE=STRING(inner)
WIDGET_CONTROL, self.dOuterLimit, SET_VALUE=STRING(outer)
angle = self.infoObj->GetAngle()
WIDGET_CONTROL, self.dAngle, SET_VALUE=STRING(angle)
END

PRO ldrsHALOTOOL::WriteDynamicContent
self->ldrsAREATOOL::WriteDynamicContent
WIDGET_CONTROL, self.dInnerRing, GET_VALUE=str1
WIDGET_CONTROL, self.dOuterRing, GET_VALUE=str2
self.infoObj->SetRing, FLOAT(str1), FLOAT(str2)
WIDGET_CONTROL, self.dInnerLimit, GET_VALUE=str1
WIDGET_CONTROL, self.dOuterLimit, GET_VALUE=str2
self.infoObj->SetLimits, FLOAT(str1), FLOAT(str2)
WIDGET_CONTROL, self.dAngle, GET_VALUE=str1
self.infoObj->SetAngle, FLOAT(str1)
END

PRO ldrsHALOTOOL::GetBoundingBoxFromDialog, x, y, w, h
WIDGET_CONTROL, self.dPosX, GET_VALUE=str1
WIDGET_CONTROL, self.dPosY, GET_VALUE=str2
px = FLOAT(str1)
py = FLOAT(str2)
WIDGET_CONTROL, self.dOuterLimit, GET_VALUE=str1
rs = FLOAT(str1)
x = px - rs
y = py - rs
w = 2*rs
h = 2*rs
END

PRO ldrsHALOTOOL::CreateContent
self->ldrsAREATOOL::CreateContent
row = self->GetFreeRow()
lab              = self->CreateLabel(0, row, 'Ring:', /HALIGN_RIGHT)
lab              = self->CreateLabel(1, row, 'inner=', /HALIGN_RIGHT)
self.dInnerRing  = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab              = self->CreateLabel(3, row, 'outer=', /HALIGN_RIGHT)
self.dOuterRing  = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
lab              = self->CreateLabel(0, row, 'Limits:', /HALIGN_RIGHT)
lab              = self->CreateLabel(1, row, 'inner=', /HALIGN_RIGHT)
self.dInnerLimit = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab              = self->CreateLabel(3, row, 'outer=', /HALIGN_RIGHT)
self.dOuterLimit = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
lab              = self->CreateLabel(0, row, 'Angle:', /HALIGN_RIGHT)
self.dAngle      = self->CreateEntry(2, row, VALUE=STRING(0.0))
row++
END

PRO ldrsHALOTOOL__define
struct = { ldrsHALOTOOL, $
           INHERITS ldrsAREATOOL, $
           dInnerRing:0, dOuterRing:0, $
           dInnerLimit:0, dOuterLimit:0, $
           dAngle:0 $
         }
END

