FUNCTION ldrsNODE::Init, recipe, cfg
;IF NOT self->IDLitComponent::Init() THEN RETURN, 0
self.recipe = recipe
self.tag = cfg->GetString('TAG')
self.label = cfg->GetString('LABEL')
cfg->GetInt3D, 'COLOR', r, g, b
self.col = [r, g, b]
cfg->GetFloat4D, 'BOX', x, y, w, h, DEFAULT=[0.0, 0.0, 1.0, 1.0]
self.box = [x, y, w, h]
self.mark = 0
RETURN, 1
END

FUNCTION ldrsNODE::GetRecipe
RETURN, self.recipe
END

FUNCTION ldrsNODE::GetTag
  RETURN, self.tag
END

FUNCTION ldrsNODE::GetLabel
  RETURN, self.label
END

FUNCTION ldrsNODE::GetColor
RETURN, self.col
END

FUNCTION ldrsNODE::GetBox
RETURN, self.box
END

FUNCTION ldrsNODE::GetMark
RETURN, self.mark
END

PRO ldrsNODE::SetMark, val
self.mark = val
END

PRO ldrsNODE__define
struct = { ldrsNODE, $
           recipe:OBJ_NEW(), $
           tag:'', $
           label:'', $
           col:[0, 0, 0], $
           box:[0.0, 0.0, 1.0, 1.0], $
           mark:0 $
           }
END
