FUNCTION ldrsPIXELTOOL::Init, view
IF NOT self->ldrsPOINTTOOL::Init(view) THEN RETURN, 0
self.dlgTitle = 'Pixel'
self.cfgPlace = 'PIXEL'
self.objClass = 'ldrsPIXEL'
self.labelPrefix = 'Pixel '
RETURN, 1
END

;FUNCTION ldrsPIXELTOOL::CreateImageObject, onr
;IF NOT OBJ_VALID(self.pixelObj) THEN self.pixelObj = OBJ_NEW(self.objClass, self, onr, self.font)
;RETURN, self.pixelObj
;END

;PRO ldrsPIXELTOOL::ImageExtensionDestroyed, imgExt, file, nr
;self.pixelObj = OBJ_NEW()
;END

;; create a new image extension object at a specified position
;PRO ldrsPIXELTOOL::CreateObject, x, y
;;PRINT, 'ldrsPIXELTOOL::CreateObject,', x, y
;IF NOT OBJ_VALID(self.pixelObj) THEN BEGIN
;    self->ldrsOBJTOOL::CreateObject, x, y
;ENDIF ELSE BEGIN
;    self.pixelObj->SetPosition, x, y
;    self->UpdateObject, self.pixelObj
;    self.view->Redraw
;ENDELSE
;IF OBJ_VALID(self.pixelObj) THEN BEGIN
;    self->Edit, self.top, self.pixelObj
;ENDIF
;END

PRO ldrsPIXELTOOL::UpdateCalculatedValues
; recalculate the values
;self.pixelObj->GetPosition, x, y
self.infoObj->GetPosition, x, y
x = FIX(x)
y = FIX(y)
view = self->GetView()
view->GetImage, img, nr
s = SIZE(*img)
IF (x EQ 0) OR (x EQ s[1]-1) THEN BEGIN
    IF (y EQ 0) OR (y EQ s[2]-1) THEN vals = FLTARR(3) ELSE vals = FLTARR(5)
ENDIF ELSE BEGIN
    IF (y EQ 0) OR (y EQ s[2]-1) THEN vals = FLTARR(5) ELSE vals = FLTARR(8)
ENDELSE
i = 0
IF (y - 1 GE 0) THEN BEGIN
    IF x - 1 GE 0 THEN BEGIN
        vals[i] = (*img)[x-1,y-1,nr]
        WIDGET_CONTROL, self.dValueBL, SET_VALUE=STRING(vals[i])
        i++
    ENDIF
    vals[i] = (*img)[x,y-1,nr]
    WIDGET_CONTROL, self.dValueB, SET_VALUE=STRING(vals[i])
    i++
    IF x + 1 LT s[1] THEN BEGIN
        vals[i] = (*img)[x+1,y-1,nr]
        WIDGET_CONTROL, self.dValueBR, SET_VALUE=STRING(vals[i])
        i++
    ENDIF
ENDIF
IF x - 1 GE 0 THEN BEGIN
    vals[i] = (*img)[x-1,y,nr]
    WIDGET_CONTROL, self.dValueL, SET_VALUE=STRING(vals[i])
    i++
ENDIF
;vals[i] = (*img)[x,y,nr]
pval = (*img)[x,y,nr]
WIDGET_CONTROL, self.dValueC, SET_VALUE=STRING(pval)
;i++
IF x + 1 LT s[1] THEN BEGIN
    vals[i] = (*img)[x+1,y,nr]
    WIDGET_CONTROL, self.dValueR, SET_VALUE=STRING(vals[i])
    i++
ENDIF
IF (y + 1 LT s[2]) THEN BEGIN
    IF x - 1 GE 0 THEN BEGIN
        vals[i] = (*img)[x-1,y+1,nr]
        WIDGET_CONTROL, self.dValueTL, SET_VALUE=STRING(vals[i])
        i++
    ENDIF
    vals[i] = (*img)[x,y+1,nr]
    WIDGET_CONTROL, self.dValueT, SET_VALUE=STRING(vals[i])
    i++
    IF x + 1 LT s[1] THEN BEGIN
        vals[i] = (*img)[x+1,y+1,nr]
        WIDGET_CONTROL, self.dValueTR, SET_VALUE=STRING(vals[i])
        i++
    ENDIF
ENDIF
med = MEDIAN(vals)
m = MEAN(vals)
v = VARIANCE(vals)
WIDGET_CONTROL, self.dMean,     SET_VALUE=STRING(m)
WIDGET_CONTROL, self.dMedian,   SET_VALUE=STRING(med)
WIDGET_CONTROL, self.dVariance, SET_VALUE=STRING(v)
WIDGET_CONTROL, self.dSigma,    SET_VALUE=STRING(SQRT(v))
WIDGET_CONTROL, self.dPixelSigma, SET_VALUE=STRING((pval - m)/SQRT(v))
END

PRO ldrsPIXELTOOL::ReadDynamicContent
self->ldrsPOINTTOOL::ReadDynamicContent
self->UpdateCalculatedValues
END

PRO ldrsPIXELTOOL::WriteDynamicContent
self->ldrsPOINTTOOL::WriteDynamicContent
self->UpdateCalculatedValues
END

PRO ldrsPIXELTOOL::DoUpdate
self->ReadDynamicContent
END

PRO ldrsPIXELTOOL::CreateContent
self->ldrsPOINTTOOL::CreateContent
row = self->GetFreeRow()
lab             = self->CreateLabel(0, row, 'Values:', /HALIGN_RIGHT)
lab             = self->CreateLabel(2, row, '-1')
lab             = self->CreateLabel(3, row, '0')
lab             = self->CreateLabel(4, row, '+1')
row++
lab             = self->CreateLabel(1, row, '+1', /HALIGN_RIGHT)
self.dValueTL   = self->CreateEntry(2, row, VALUE=STRING(0.0))
self.dValueT    = self->CreateEntry(3, row, VALUE=STRING(0.0))
self.dValueTR   = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
lab             = self->CreateLabel(1, row, '0', /HALIGN_RIGHT)
self.dValueL    = self->CreateEntry(2, row, VALUE=STRING(0.0))
self.dValueC    = self->CreateEntry(3, row, VALUE=STRING(0.0))
self.dValueR    = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
lab             = self->CreateLabel(1, row, '-1', /HALIGN_RIGHT)
self.dValueBL   = self->CreateEntry(2, row, VALUE=STRING(0.0))
self.dValueB    = self->CreateEntry(3, row, VALUE=STRING(0.0))
self.dValueBR   = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++

lab             = self->CreateLabel(0, row, 'Statistics:', /HALIGN_RIGHT)
lab             = self->CreateLabel(1, row, 'mean=', /HALIGN_RIGHT);
self.dMean      = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab             = self->CreateLabel(3, row, 'median=', /HALIGN_RIGHT);
self.dMedian    = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
lab             = self->CreateLabel(1, row, 'var=', /HALIGN_RIGHT);
self.dVariance  = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab             = self->CreateLabel(3, row, 'sigma=', /HALIGN_RIGHT);
self.dSigma     = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++

lab              = self->CreateLabel(0, row, 'Deviation:', /HALIGN_RIGHT)
self.dPixelSigma = self->CreateEntry(2, row, VALUE=STRING(0.0))
row++
END

PRO ldrsPIXELTOOL::CreateButtons
self->ldrsPOINTTOOL::CreateButtons
self.dlgUpdateButton = WIDGET_BUTTON(self.dlgButtons, VALUE='Update', EVENT_PRO='LDRS_DIALOG_UPDATE', UVALUE=self)
END

PRO ldrsPIXELTOOL__define
struct = { ldrsPIXELTOOL, $
           INHERITS ldrsPOINTTOOL, $
           dlgUpdateButton:0, $
           pixelObj:OBJ_NEW(), $
           dValueTL:0, dValueT:0, dValueTR:0, $
           dValueL:0, dValueC:0, dValueR:0, $
           dValueBL:0, dValueB:0, dValueBR:0, $
           dMean:0, dMedian:0, dVariance:0, dSigma:0, $
           dPixelSigma:0 $
         }
END
