FUNCTION ldrsPOINTTOOL::Init, view
IF NOT self->ldrsOBJTOOL::Init(view) THEN RETURN, 0
self.dlgTitle = 'Point'
self.cfgPlace = 'IMGPOINT'
self.objClass = 'ldrsIMGPOINT'
self.labelPrefix = 'Point '
RETURN, 1
END

;PRO ldrsPOINTTOOL::DoRecenter
;self.infoObj->AdjustCenter
;self.infoObj->Update
;self->UpdateObject, self.infoObj
;self.view->Redraw
;self->ReadDynamicContent
;END

PRO ldrsPOINTTOOL::ButtonPressed, id
IF id EQ self.dPosGuess THEN BEGIN
    proc = LDRS_GET_PROCEDURE('CALCCENTER', self.posAlgo)
    self.infoObj->AdjustCenter, proc
    self.infoObj->Update
    self->UpdateObject, self.infoObj
    self.view->Redraw
    self->ReadDynamicContent
ENDIF
END

PRO ldrsPOINTTOOL::ReadDynamicContent
self->ldrsOBJTOOL::ReadDynamicContent
self.infoObj->GetPosition, x, y
self.pX = x
self.pY = y
WIDGET_CONTROL, self.dPosX, SET_VALUE=STRING(x)
WIDGET_CONTROL, self.dPosY, SET_VALUE=STRING(y)
END

PRO ldrsPOINTTOOL::WriteDynamicContent
self->ldrsOBJTOOL::WriteDynamicContent
WIDGET_CONTROL, self.dPosX, GET_VALUE=str1
WIDGET_CONTROL, self.dPosY, GET_VALUE=str2
self.pX = FLOAT(str1)
self.pY = FLOAT(str2)
self.infoObj->SetPosition, self.pX, self.pY
END

PRO ldrsPOINTTOOL::SetPosAlgo, id, item
self.posAlgo = item
END

PRO ldrsPOINTTOOL::CreateContent
self->ldrsOBJTOOL::CreateContent
row = self->GetFreeRow()
lab              = self->CreateLabel(0, row, 'Position:', /HALIGN_RIGHT)
self.dPosAlgo    = self->CreateProcedureMenu(2, row, 'CALCCENTER', 'SetPosAlgo')
self.dPosGuess   = self->CreateButton(3, row, 'Recenter', /HALIGN_LEFT, NX=2)
row++

lab              = self->CreateLabel(1, row, 'x=', /HALIGN_RIGHT)
self.dPosX       = self->CreateEntry(2, row, VALUE=STRING(0.0))
lab              = self->CreateLabel(3, row, 'y=', /HALIGN_RIGHT)
self.dPosY       = self->CreateEntry(4, row, VALUE=STRING(0.0))
row++
END

PRO ldrsPOINTTOOL::CreateButtons
self->ldrsDIALOG::CreateButtons
;self.dlgRecenterButton = WIDGET_BUTTON(self.dlgButtons, VALUE='Recenter', EVENT_PRO='LDRS_DIALOG_RECENTER', UVALUE=self)
END

PRO ldrsPOINTTOOL__define
struct = { ldrsPOINTTOOL, $
           INHERITS ldrsOBJTOOL, $
           pX:0.0, pY:0.0, $
           dPosX:0, dPosY:0, $
           dPosAlgo:0, posAlgo:0, dPosGuess:0, $
           dlgRecenterButton:0 $
         }
END

