FUNCTION LDRS_DECODE_FILENAME, recName, fileName
;PRINT, 'LDRS_DECODE_FILENAME, ', recName, ', ', fileName
recPath  = STRSPLIT(recName,  PATH_SEP(), /EXTRACT)
filePath = STRSPLIT(fileName, PATH_SEP(), /EXTRACT)
recPathLen  = N_ELEMENTS(recPath)
filePathLen = N_ELEMENTS(filePath)
resPath = STRARR(recPathLen - 1 + filePathLen + 1)
resPath[0] = ''
resPath[1:recPathLen - 1] = recPath[0:recPathLen - 2]
resPath[recPathLen:recPathLen - 1 + filePathLen] = filePath[0:filePathLen - 1]
resFile = STRJOIN(resPath, PATH_SEP())
resFile = FILE_EXPAND_PATH(resFile)
;PRINT, '  decoded: ', resFile
RETURN, resFile
END
