FUNCTION ldrsPSFSTAR::Init, tool, nr, font
IF NOT self->ldrsIMGAREA::Init(tool, nr, font) THEN RETURN, 0
;PRINT, 'ldrsPSFSTAR::Init, col=', self.col
self.crossFlag = 1
self.labelFlag = 1
self.boxFlag = 1
self.mMode = 1 ; left == right, bottom == top => rectangular, centered
RETURN, 1
END

PRO ldrsPSFSTAR::GetHalo, haloAlgo
haloAlgo = self.haloAlgo
END

PRO ldrsPSFSTAR::SetHalo, haloAlgo
self.haloAlgo = haloAlgo
END

PRO ldrsPSFSTAR::Store, cfg
self->ldrsIMGAREA::Store, cfg
cfg->SetInt, 'HALOALGO', self.haloAlgo
END

PRO ldrsPSFSTAR::Load, cfg
self->ldrsIMGAREA::Load, cfg
self.haloAlgo = cfg->GetInt('HALOALGO')
self->Update
END

PRO ldrsPSFSTAR__define
  struct = { ldrsPSFSTAR, $
             INHERITS ldrsIMGAREA, $
             haloAlgo:0 $
           }
END
