FUNCTION ldrsPSFTOOL::Init, view
IF NOT self->ldrsAREATOOL::Init(view) THEN RETURN, 0
self.dlgTitle = 'Psf'
self.cfgPlace = 'PSFSTAR'
self.objClass = 'ldrsPSFSTAR'
self.labelPrefix = 'Psf '
self.mMode = 1
RETURN, 1
END

PRO ldrsPSFTOOL::InitObject, obj, x, y
;self->ldrsOBJTOOL::InitObject, obj, x, y
proc = LDRS_GET_PROCEDURE('CALCCENTER', self.posAlgo)
obj->SetPosition, x, y, /ADJUST, CENTER_PROC=proc
obj->SetMargins, 128, 128, 128, 128
END

PRO ldrsPSFTOOL::ReadDynamicContent
self->ldrsAREATOOL::ReadDynamicContent
self.infoObj->GetHalo, haloAlgo
self.haloAlgo = haloAlgo
WIDGET_CONTROL, self.dHaloAlgo, SET_COMBOBOX_SELECT=haloAlgo
END

PRO ldrsPSFTOOL::WriteDynamicContent
self->ldrsAREATOOL::WriteDynamicContent
self.infoObj->SetHalo, self.haloAlgo
END

PRO ldrsPSFTOOL::ItemSelected, id, item
self->ldrsAREATOOL::ItemSelected, id, item
IF id EQ self.dHaloAlgo THEN self.haloAlgo = item
END

PRO ldrsPSFTOOL::SetHalo, id, item
self.haloAlgo = item
END

PRO ldrsPSFTOOL::CreateContent
self->ldrsAREATOOL::CreateContent
row = self->GetFreeRow()
lab              = self->CreateLabel(0, row, 'Halo:', /HALIGN_RIGHT)
;lab              = self->CreateLabel(1, row, 'algo=', /HALIGN_RIGHT)
self.dHaloAlgo   = self->CreateProcedureMenu(2, row, 'HALOC', 'SetHalo')
row++
END

PRO ldrsPSFTOOL__define
struct = { ldrsPSFTOOL, $
           INHERITS ldrsAREATOOL, $
           dHaloAlgo:0, $
           haloAlgo:-1 $
         }
END

