FUNCTION ldrsVIEWTOOL::Init, view
IF NOT self->ldrsTOOLIMPL::Init(view) THEN RETURN, 0

RETURN, 1
END

PRO ldrsVIEWTOOL::CreateContent
self->ldrsTOOLIMPL::CreateContent
END

PRO ldrsVIEWTOOL::CreateImageExtension, imgExt, file, nr
END

PRO ldrsVIEWTOOL::PressLeft, modifiers, x, y
END

PRO ldrsVIEWTOOL::PressMiddle, modifiers, x, y
;IF modifiers NE 1 THEN RETURN
self.panFlag = 1
self.panedFlag = 0
self.refX = x
self.refY = y
self.resX = 0
self.resY = 0
END

PRO ldrsVIEWTOOL::PressRight, modifiers, x, y
END

PRO ldrsVIEWTOOL::ReleaseLeft, modifiers, x, y
;IF modifiers NE 1 THEN RETURN
;PRINT, 'ldrsVIEWTOOL::ReleaseLeft,', x, y
self.view->ChangeView, ZOOM=1, GCENTER=[x, y]
END

PRO ldrsVIEWTOOL::ReleaseMiddle, modifiers, x, y
;IF modifiers NE 1 THEN RETURN
;PRINT, 'ldrsVIEWTOOL::ReleaseMiddle,', x, y
self.panFlag = 0
IF NOT self.panedFlag THEN self.view->ChangeView, GCENTER=[x, y]
END

PRO ldrsVIEWTOOL::ReleaseRight, modifiers, x, y
;IF modifiers NE 1 THEN RETURN
;PRINT, 'ldrsVIEWTOOL::ReleaseRight,', x, y
self.view->ChangeView, ZOOM=-1, GCENTER=[x, y]
END

PRO ldrsVIEWTOOL::Move, modifiers, x, y
;IF modifiers NE 1 THEN RETURN
IF NOT self.panFlag THEN RETURN
res = [0, 0]
self.view->ChangeView, MOVE=[x - self.refX + self.resX, y - self.refY + self.resY], RESIDUAL=res
self.refX = x
self.refY = y
self.resX = res[0]
self.resY = res[1]
self.panedFlag = 1
END

PRO ldrsVIEWTOOL::Activate, view
self->ldrsTOOLIMPL::Activate, view
self->ShowInfo, 'L: zoom in, M: pan, R: zoom out'
END

PRO ldrsVIEWTOOL__define
struct = { ldrsVIEWTOOL, $
           INHERITS ldrsTOOLIMPL, $
           panFlag:0, $
           panedFlag:0, $
           refX:0, $
           refY:0, $
           resX:0, $
           resY:0 $
         }
END
